#include <bits/stdc++.h>

using namespace std;

#define mp make_pair
#define X first
#define F first
#define Y second
#define S second
#define EPS 1e-5
#define MAXN 10005
typedef pair<double,double> pdd;

int N;
double xMin, xMax;
pdd p[MAXN];

void Read() {
    scanf("%d %lf %lf", &N, &p[1].X, &p[1].Y);
    xMin = xMax = p[1].X;
    for (int i=2; i<=N; ++i) {
        scanf("%lf %lf", &p[i].X, &p[i].Y);
        xMin = min(xMin,p[i].X);
        xMax = max(xMax,p[i].Y);
    }
}

inline double sq(double a){
    return a*a;
}

double CCW(pdd a, pdd b, pdd c) {
    return (b.X-a.X)*(c.Y-a.Y) - (b.Y-a.Y)*(c.X-a.X);
}

double Length(pdd a, pdd b) {
    return sqrt(sq(a.X-b.X) + sq(a.Y-b.Y));
}

inline bool Equal(double a, double b) {
    return fabs(a-b) < EPS;
}

double Dist(pdd from, pdd p1, pdd p2) {
    if ( Equal(p1.X,p2.X) && Equal(p1.Y,p2.Y) )
        return Length(from,p1);
    return fabs(CCW(from, p1, p2) / Length(p1,p2));
}

double Circle(pdd from) {
    double minRad = Dist(from, p[1], p[N]);
    for(int i=1; i<N; ++i) {
        minRad = min(minRad,Dist(from, p[i],p[i+1]));
    }
    return minRad;
}

double PointX(pdd a, pdd b, double x) {
    return a.Y + (a.Y-b.Y)/(a.X-b.X) * (x-a.X);
}

pdd yLim(double x){
    int cnt=0;
    double ys[2];
    for (int i=1; i<=N; ++i) {
        int j = (i%N)+1;
        if ( min(p[i].X,p[j].X) <= x && x <= max(p[i].X,p[j].X) ) {
            ys[cnt++] = PointX(p[i],p[j],x);
        }
    }

    return mp(ys[0], ys[1]);
}

double yMaxCircle(double x) {
    pdd yLimit = yLim(x);
    double lo, hi, yMid1, yMid2;
    lo = min(yLimit.F,yLimit.S);
    hi = max(yLimit.F,yLimit.S);

    while ( fabs(hi-lo) > EPS) {
        yMid1 = (2*lo+hi) / 3;
        yMid2 = (lo+2*hi) / 3;
        if ( Circle(mp(x,yMid1)) < Circle(mp(x,yMid2)) ) {
            lo = yMid1;
        } else {
            hi = yMid2;
        }
    }

    return lo;
}

void Solve() {
    double lo, hi, xMid1, xMid2;
    lo = xMin;
    hi = xMax;

    while ( fabs(hi-lo) > EPS) {
        xMid1 = (2*lo+hi) / 3;
        xMid2 = (lo+2*hi) / 3;
        if ( Circle(mp(xMid1,yMaxCircle(xMid1))) < Circle(mp(xMid2,yMaxCircle(xMid2))) ) {
            lo = xMid1;
        } else {
            hi = xMid2;
        }
    }

    printf("%.3lf\n", Circle(mp(lo, yMaxCircle(lo))));
}

int main() {
    Read();
    Solve();
}
